<script lang="ts">
  import { createEventDispatcher } from "svelte";
  import { defaultSettings, validPlayerCounts } from "./settings";
  const dispatch = createEventDispatcher();

  export let settings: GameSettings = defaultSettings;
  export let readonly: boolean = false;

  let selectedPlayerCounts = [...settings.selectedPlayerCounts];

  let settingsChange: GameSettings;
  $: settingsChange = {
    selectedPlayerCounts,
  };

  $: dispatch("settings_change", settingsChange);
</script>

<section>
  <fieldset>
    <legend>Player counts</legend>

    <ul>
      {#each validPlayerCounts as c (c)}
        <li>
          <label class="player-count" for="player-count-{c}">
            <input
              id="player-count-{c}"
              type="checkbox"
              bind:group={selectedPlayerCounts}
              value={c}
              disabled={readonly}
            />
            {c}
          </label>
        </li>
      {/each}
    </ul>
    <ul>
      <li>
        <small>Recommended: 2-5</small>
      </li>
      <li>
        <small>Best: 4</small>
      </li>
    </ul>
  </fieldset>
</section>

<style>
  section {
    padding-bottom: 1rem;
    display: grid;
    row-gap: 1em;
  }

  fieldset {
    border: 0;
    padding: 0;
    margin: 0;
  }
  legend {
    padding: 0;
  }
  ul {
    margin: 0;
    display: flex;
    flex-wrap: wrap;
    column-gap: 1em;
  }
  li {
    white-space: nowrap;
  }

  small {
    filter: opacity(90%);
  }
</style>
